<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from builder.texi on 28 April 1999 -->

<TITLE>The Builder Library - Cloning</TITLE>
<link href="builder_27.html" rel=Next>
<link href="builder_25.html" rel=Previous>
<link href="builder_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_25.html">previous</A>, <A HREF="builder_27.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC57" HREF="builder_toc.html#TOC57">Cloning</A></H2>
<P>
When creating a <CODE>block</CODE> out of a SUIF structure, unless
specified otherwise, a clone of the SUIF structure is created.  The
builder can be instructed not to clone by setting an optional
<CODE>duplicate</CODE> argument to FALSE.
When a builder structure is created without cloning, the first use of
that block will receive the original SUIF structure.  Subsequent
uses will get a cloned copy.
Thus, the following code will generate correct results.

<PRE>
        tree_node_list * tnl = ...
        block body(tnl, FALSE);
        block code(block::IF(cond, body, body));
</PRE>

<P>
<A NAME="IDX140"></A>
But the next example will generate INCORRECT SUIF since the same
SUIF structure is illegally reused.  This is a problem since SUIF
structures generally exist in a larger data structure and contain parent
pointers.  Thus a SUIF structure can not exist in two places at once.

<PRE>
        tree_node_list * tnl = ...
        block code(block::IF(cond, block(tnl, FALSE), block(tnl, FALSE)));
</PRE>

<P>
<A NAME="IDX141"></A>

</P>
<P><HR><P>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_25.html">previous</A>, <A HREF="builder_27.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
</BODY>
</HTML>
